﻿using UnityEngine;

public class SmoothCamera2d : MonoBehaviour {
    public static SmoothCamera2d here;
    private const float defaultFOV = 40;
    private Camera mCam;
	public float dampTime = 0.15f;
	private Vector3 velocity = Vector3.zero;
	public Transform target;

    public const float scrollSpeed = 300;
    private float waitToLerp;

    private void Start()
    {
        here = this;
        mCam = GetComponent<Camera>();
        mCam.fieldOfView = defaultFOV;
    }

    // Update is called once per frame
    void Update() {
        float scroll = Input.GetAxis("Mouse ScrollWheel");
        mCam.fieldOfView -=scroll  * scrollSpeed * Time.deltaTime;
        mCam.fieldOfView = Mathf.Clamp(mCam.fieldOfView, 15, 60);

        #region Camera Scrolling
            waitToLerp = (scroll != 0) ? 0 : waitToLerp;

            waitToLerp += Time.deltaTime;

            if (waitToLerp >= 3.5f)
            {
                mCam.fieldOfView = Mathf.Lerp(mCam.fieldOfView, defaultFOV, 1.5f * Time.deltaTime);
            }
#endregion

        if (target) {
			Vector3 point = Camera.main.WorldToViewportPoint(target.position);
			Vector3 delta = target.position - Camera.main.ViewportToWorldPoint(new Vector3(0.5f, 0.5f, point.z));
			Vector3 destination = transform.position + delta;
			transform.position = Vector3.SmoothDamp(transform.position, destination, ref velocity, dampTime);
		}

	}
}