﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class CoreManager : MonoBehaviour {
    private GameObject fireandSmoke;
    private GameObject explosion;
    private Image health;
    private Image inner;
    public GameObject replayPanel;
    public Text goText;
    //
    private const float maxHealth = 200;
    public float currHealth;

    private static bool dead;

	void Start () {
        setDisplay();
        
        GetComponent<SphereCollider>().radius = 90;
        currHealth = maxHealth;

        explosion = Instantiate(Resources.Load("BigExplosionEffect")) as GameObject;
        explosion.transform.position = transform.position;
        explosion.SetActive(false);
        //
        fireandSmoke = Instantiate(Resources.Load("PerformanceLitSmokeAndFire")) as GameObject;
        fireandSmoke.transform.position = transform.position;
        fireandSmoke.SetActive(false);
    }

    private void OnEnable()
    {
        currHealth = maxHealth;
        dead = false;

        if(fireandSmoke.activeSelf)
        {
            fireandSmoke.SetActive(false);
        }

        if(explosion.activeSelf)
        {
            explosion.SetActive(false);
        }
    }

    // Update is called once per frame
    void Update () {
        inner.fillAmount = currHealth / maxHealth;

        if(inner.fillAmount < .4f)
        {
            if(!fireandSmoke.activeSelf)
            {
                fireandSmoke.SetActive(true);
            }  
        }

        if (inner.fillAmount <= 0)
        {
            if (!dead) {
                StartCoroutine(Kill());
                dead = true;
            }
        }
	}

    public void TakeDamage(float damage)
    {
        currHealth -= damage;
    }


    private IEnumerator Kill()
    {
        //print()
        SmoothCamera2d.here.target = transform;
        yield return new WaitForSeconds(2.5f);
        Time.timeScale = .25f;
        //
        explosion.SetActive(true);
        fireandSmoke.SetActive(false);
        gameObject.SetActive(false);

      
       Time.timeScale = Mathf.Lerp(Time.timeScale, 1, .1f);
        goText.gameObject.SetActive(true);
        replayPanel.SetActive(true);
        Invoke("GameOver", 1.5f);   
    }

    private void GameOver()
    {

        Time.timeScale = 1;
        //
        print("Game Over");
    }

    private void setDisplay()
    {
        health = GameObject.Find("CoreHealth").GetComponent<Image>();
        inner = health.gameObject.transform.GetChild(0).GetComponent<Image>();
        //health.transform.position = transform.position + Vector3.up * (2.5f) + Vector3.forward * 1f ;
        //health.transform.position = new Vector3(-498.75f, -199f, 24.5f);
        health.transform.localScale = new Vector3(5, 1, 1);
        //
        RectTransform rec = health.GetComponent<RectTransform>();
        rec.position = new Vector3(7.25f, 4, 24.5f);
        //rec.eulerAngles = rec.eulerAngles + Vector3.right * 90;


        goText = GameObject.Find("GAMEOVER").GetComponent<Text>();
        goText.transform.position = transform.position;
        RectTransform gec = health.GetComponent<RectTransform>();
        gec.eulerAngles = rec.eulerAngles + Vector3.right * 90;
        goText.gameObject.SetActive(false);

        replayPanel = GameObject.Find("ReplayPanel");
        replayPanel.SetActive(false);
    }

    public static bool coreActive
    {
      get {
            return !dead;
        }
    }
}
