﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class DefenderCombat : MonoBehaviour {
    //Refs
    private DefenderBehavior behavior;
    private SphereCollider sphere;

    //Accesories
    private Transform pivot;    //Turning part of turret
    private const float pivotSpeed = 7.5f;

    //Enemy
    private const int enemyLayer = 9;
    public Transform target;

    //Weapon
    //public List<Transform> barrels;
    private bool attacking;

    void Start () {
        behavior = GetComponent<DefenderBehavior>();
        sphere = gameObject.AddComponent<SphereCollider>();
        sphere.isTrigger = true;
        sphere.radius = 50;
        sphere.center = Vector3.zero + transform.up * 1.5f;
        //
        //barrels = new List<Transform>();
		foreach(Transform child in transform.GetComponentsInChildren<Transform>())
        {
            if(child.CompareTag("Pivot"))
            {
                pivot = child;
            }else if(child.CompareTag("Barrel"))
            {
                //barrels.Add(child);
            }
        }

        if (pivot == null)
            return;

        foreach (Transform child in pivot.GetComponentsInChildren<Transform>())
        {
          if (child.CompareTag("Barrel"))
            {
                //barrels.Add(child);
            }
        }
    }
	
	// Update is called once per frame
	void Update () {
        if (!behavior.ActiveState)
            return;

        //Find target
        Collider[] hitColliders = Physics.OverlapSphere(transform.position, 10, 1 << LayerMask.NameToLayer("Enemy"));
        float nearestDistance = float.MaxValue;
        Transform localTarget = null;
        foreach (Collider hit in hitColliders)
        {
            float distance = Vector3.Distance(hit.transform.position, transform.position);
            if (distance < nearestDistance)
            {
                localTarget = hit.transform;
                nearestDistance = distance;
            }
        }
        target = localTarget;
        if (pivot != null)
        {
            if (target != null)
            {
                if(!attacking)
                {
                    StartCoroutine(Attack());
                    attacking = true;
                }

                var pos = target.position - transform.position;
                pos.y = 0;
                var look = Quaternion.LookRotation(pos);
                //pivot.rotation = Quaternion.Slerp(pivot.rotation, look,
                //      (pivotSpeed * 1.5f) * Time.deltaTime);
                pivot.rotation = look;
            }
            else
            {
                pivot.Rotate(transform.up * pivotSpeed * Time.deltaTime);
            }
        }
	}


    private IEnumerator Attack()
    {
        GameObject obj = GeneralObjectPool.here.GetBullet();
        obj.transform.position = transform.position;
        obj.transform.rotation = pivot.rotation;
        obj.SetActive(true);
        AudioSource audio = GetComponent<AudioSource>();
        audio.Play();
        yield return new WaitForSeconds(.25f);
        /*
        for (int i =0; i < barrels.Count; i++) {
            if (!behavior.ActiveState)
                break;

            GameObject obj = GeneralObjectPool.here.GetBullet();
            obj.transform.position = barrels[i].position;
            obj.transform.rotation = barrels[i].transform.rotation;
            obj.SetActive(true);
            yield return new WaitForSeconds(.25f);
        }

        yield return new WaitForSeconds(.2f);
        */
        if(target != null && behavior.ActiveState)
        {
            StartCoroutine(Attack());
        }
        else
        {
            attacking = false;
        }
    }

    private void OnTriggerStay(Collider other)
    {
        GameObject obj = other.gameObject;
        if (obj.layer == enemyLayer)
        {
            
                target = obj.transform;
            
        }
    }

    private void OnTriggerExit(Collider other)
    {
        target = null;
    }
}
