﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Assets.Scripts.Systems;

public class HealthController : MonoBehaviour {
    public float maxHealth;
    public float currHealth;

    private bool dead;

    private void OnEnable()
    {
        currHealth = maxHealth;
        dead = false;
    }
  
    void Update () {
		if(!dead && currHealth <= 0)
        {
            StartCoroutine(kill());
            dead = true;
        }
	}

    public void TakeDamage(float damage)
    {
        currHealth -= damage;
    }

    private IEnumerator kill()
    {
        AIController controller = GetComponent<AIController>();
        if (controller != null)
        {
            gameObject.SetActive(false);
            if (controller.type != EnemyType.NotEnemy)
            {
                GameManager.instance.DeadEnemy(controller.type);
            }
        }
        yield return null;
    }
}
