﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine.UI;
using UnityEngine;
using DigitalRuby.LightningBolt;
using Assets.Scripts.Systems;

public class MCursor : MonoBehaviour {
    public GameObject core;
    //Raycast
    private const int gridLayer = 8;
    public int sensorLength = 256;

    //Grid Selection
    private GameObject lastSelected;
    public float boxDimen;

    private GameObject testTurret;
    public bool blocked;
    private bool clicked;

    public Texture2D target;
    void Start() {
        //testTurret =  as GameObject;
        //GetComponent<Collider>().isTrigger = true;
        //Cursor.SetCursor(target, Vector2.zero, CursorMode.Auto);
    }


    void Update() {
        if(core == null)
        {
            core = GameObject.FindGameObjectWithTag("Core");
        }
        /* Old 3d mouse code
        #region mouse cursor
        Cursor.visible = false;
        ///Mouse Cursor movement
        var v3 = Input.mousePosition;
        v3.z = 10;
        Vector3 mouse = Camera.main.ScreenToWorldPoint(v3);
        transform.position = new Vector3(mouse.x, transform.position.y, mouse.z);
        #endregion
        */
    }

    void OnDrawGizmos() {
        Gizmos.DrawRay(transform.position, -transform.up *
            (sensorLength * transform.localScale.z));
    }

    private void FixedUpdate()
    {
        
        RaycastHit hit;
        Ray mouseRay = Camera.main.ScreenPointToRay(Input.mousePosition);
        if (Physics.Raycast(mouseRay, out hit, sensorLength, 1 << gridLayer))
        {
            GameObject obj = hit.collider.gameObject;

            if (obj.layer == gridLayer)
            {
                obj.GetComponent<MyHexagon>().fadeToSelected();
                GameObject turret;
                if(GameManager.instance.OccupiedHexagons.TryGetValue((MyHexagon)obj.GetComponent<MyHexagon>(), out turret))
                {
                    turret.GetComponent<DefenderBehavior>().showBattey();
                    if (Input.GetMouseButtonDown(0))
                    {
                        turret.GetComponent<DefenderBehavior>().activate();
                    }
                }
                else if (Input.GetMouseButton(0) && GameManager.instance.GetState() == GameState.Building)
                {
                    place(obj);
                }

                /*  if (lastSelected != obj)
                  {
                      if (lastSelected != null)
                      {
                          Material lastMat = lastSelected.GetComponent<MeshRenderer>().material;
                          lastMat.color = Color.white;
                      }

                      lastSelected = obj;
                  }

                  Material mat = obj.GetComponent<MeshRenderer>().material;
                  mat.color = Color.red;*/
            }
        }
    }

    //Places a gameobject on a hex
    private void place(GameObject obj)
    {
        if (!GameManager.instance.BuyTurret())
            return;
        GameObject curr = (GameObject)Instantiate(Resources.Load("MachineGun"), obj.transform.position +
            transform.up * 1, Quaternion.identity, obj.transform);

        DefenderBehavior behave = curr.GetComponent<DefenderBehavior>();

        var local = curr.transform.localPosition;
        local.y = 0;

        curr.transform.localScale = Vector3.one * .75f;
        GameManager.instance.OccupiedHexagons.Add((MyHexagon)obj.GetComponent<MyHexagon>(), curr);

        GameObject lightning = GeneralObjectPool.here.GetLighting();

        lightning.SetActive(true);
        behave.lightning = lightning;
        LightningBoltScript bolt = lightning.GetComponent<LightningBoltScript>();
        bolt.StartObject = core;
        bolt.EndObject = curr;
        
    }

    private void OnTriggerStay(Collider other)
    {
        /*float distance = Vector3.Distance(transform.position, other.transform.position);
        blocked = ((other.CompareTag("Defender") || other.CompareTag("Core")) && distance < 2);
        //
        if (other.CompareTag("Defender")) {
            DefenderBehavior behave = other.GetComponent<DefenderBehavior>();

            if (Input.GetMouseButton(0))
            {
                if (!clicked) {
                    behave.activate();
                    clicked = true;
                }
            }

            if(Input.GetMouseButtonUp(0))
            {
                clicked = false;
            }
            
            behave.showBattey();
            }
        */
    }

    private void OnTriggerExit(Collider other)
    {
        //blocked = !(other.CompareTag("Defender") || other.CompareTag("Core"));
    }
}
