﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using Assets.Scripts.Systems;

public class XMissionController : MonoBehaviour {
    public Image powerFill;
    public static XMissionController transmitter;

	void Start () {
        transmitter = this;
        powerFill = GameObject.Find("POWER").GetComponent<Image>();
	}

    // Update is called once per frame
    void Update () {
        #region UI Indication
        powerFill.fillAmount = GameManager.instance.CurrentPower / GameManager.MAX_POWER;
        Color currColor = (powerFill.fillAmount < .25f) ? Color.red : Color.white;
        powerFill.color = Color.Lerp(powerFill.color, currColor, 1.5f * Time.deltaTime);
    #endregion
    }

    private void OnGUI()
    {
        if (GameManager.instance.GetState() == GameState.Building)
        {
            if (GUI.Button(new Rect(5, 5, 100, 30), "Begin Wave!"))
                GameManager.instance.BeginBattle();
        }
        GUI.TextArea(new Rect(5, 40, 100, 20), "Currency: " + GameManager.instance.Currency);
        GUI.TextArea(new Rect(5, 70, 100, 20), "Wave: " + GameManager.instance.GetWave());
    }
}
