﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class GeneralObjectPool : MonoBehaviour {
	public static GeneralObjectPool here;
	public const int pooledAmount = 20;
	public const bool doExpand = true;

    #region Weapons
    private GameObject pooledBullet;
    private List<GameObject> pooledBullets;

    private GameObject pooledLightning;
    private List<GameObject> pooledLigthnings;
#endregion


	void Start () {
        here = this;

        #region Setting
        pooledBullet = Resources.Load("Bullet") as GameObject;
        pooledBullets = new List<GameObject>();

        pooledLightning = Resources.Load("SimpleLightningBoltPrefab") as GameObject;
        pooledLigthnings = new List<GameObject>();
        #endregion

        #region Pooling
        for (int i = 0; i < pooledAmount; i++)
        {
            GameObject obj = (GameObject)Instantiate(pooledBullet);
            obj.SetActive(false);
            pooledBullets.Add(obj);
        }

        for (int i = 0; i < pooledAmount; i++)
        {
            GameObject obj = (GameObject)Instantiate(pooledLightning);
            obj.SetActive(false);
            pooledLigthnings.Add(obj);
        }
        #endregion
    }

    public GameObject GetBullet()
    {
        for (int i = 0; i < pooledAmount; i++)
        {

            if (!pooledBullets[i].activeInHierarchy)
            {
                return pooledBullets[i];
            }
        }

        if (doExpand)
        {
            GameObject obj = (GameObject)Instantiate(pooledBullet);
            pooledBullets.Add(obj);
            return obj;
        }
    }

    public GameObject GetLighting()
    {
        for (int i = 0; i < pooledAmount; i++)
        {

            if (!pooledLigthnings[i].activeInHierarchy)
            {
                return pooledLigthnings[i];
            }
        }

        if (doExpand)
        {
            GameObject obj = (GameObject)Instantiate(pooledLightning);
            pooledLigthnings.Add(obj);
            return obj;
        }
    }
}
