﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Assets.Scripts.Systems;

namespace Assets.Scripts.Utilities
{
    class Difficulty
    {
        private const float PHASE_LENGTH = 5;
        public static float Set(EnemySpawnMaster spawnMaster, int wave)
        {
            float phase = wave / PHASE_LENGTH;
            float startIntensity = wave +  ((wave - 1) * GameManager.MAX_INTENSITY / 2);
            spawnMaster.SetSideIntensities(HexSide.Top, startIntensity);
            if (phase > 1)
                spawnMaster.SetSideIntensities(HexSide.Bottom, startIntensity - PHASE_LENGTH);
            if (phase > 2)
                spawnMaster.SetSideIntensities(HexSide.TopLeft, startIntensity - (PHASE_LENGTH * 2));
            if (phase > 3)
                spawnMaster.SetSideIntensities(HexSide.BottomRight, startIntensity - (PHASE_LENGTH * 3));
            if (phase > 4)
                spawnMaster.SetSideIntensities(HexSide.BottomLeft, startIntensity - (PHASE_LENGTH * 4));
            if (phase > 5)
                spawnMaster.SetSideIntensities(HexSide.TopRight, startIntensity - (PHASE_LENGTH * 5));

            return 30f;
        }
    }
}
